**Exploring Unrolled Optimization**

Authors: Samir Agarwala, Jared Watrous

In this project, we explore data-driven approaches to learn the hyperparameters needed for the HQS algorithm for denoising images on the MNIST dataset.

We provide an environment.yaml file to setup a conda environment to run the code in this repository. If the setup does not work, we recommend following the setup instructions provided for the homework environment and installing any missing packages as we did to set up our project environment.

To train all methods mentioned in the report:

```python
python run_exps.py
```

To train a method:

```
python run.py --train --config-file <filename.yaml>
```

To evaluate a method:

```python
python run.py --test --config-file <filename.yaml>
```

To generate figures for the methods:

```python
python create_fig.py
```

Sample configuration files used in our project are provided under the configs directory. For exact specifications for experiments please refer to the run_exps.py file which automates configuration creation and runs all the experiments based on the given repository structure. 

Lastly, there is no need for dataset setup in our project since the code should set up MNIST automatically the first time that you run it.

**Acknowledgements**

We would like to thank Prof. Gordon Wetzstein for helpful discussions and feedback. We also acknowledge that we adapted starter code or our solutions to homework coding problems for CS 448I at Stanford during the implementation of this project. The pretrained denoising neural network used in our project is also taken from starter code from a coding homework of CS 448I.